/*
 * $Id: pmap.h,v 1.2 2001/01/12 10:44:26 romanp Exp $
 */


#define MAXNAMLEN	255

struct	l_nch {
    u_long	vp;			/* vnode */
    u_long	dvp;			/* parent vnode */
    u_long  	id, did;		/* vnode id, parent vnode id */
    u_long 	flag, dflag;		/* vnode flags, parent vnode flags */
    enum vtype 	vp_type, dvp_type;	/* vnode type, parent vnode type */
    char 	name[MAXNAMLEN+1];	/* FS object name */
    struct l_nch *pa;			/* address of parent vnode l_nch */
};

struct l_nchash {
    u_long 		n_idx;
    struct l_nch 	*l_nch;
};

typedef struct _bit_t {
    char 	name[32];
    u_long 	mask;
} bit_t;

int namec_load(void);
char *namec_lookup(u_long, u_long);
char *make_vmo_type(u_char);
char *make_vn_type(enum vtype);
char *make_vn_tag(enum vtagtype);
char *print_bits(u_long, bit_t *);

/* kernel-related functions */
int k_open(void);
int k_read(u_long, void *, size_t);
int k_close(void);
struct kinfo_proc *k_getallprocs(int *);
struct nlist;
int k_nlist(struct nlist*);
