/* 
 * $Id: utils.c,v 1.2 2001/01/12 10:44:26 romanp Exp $ 
 */

#include <sys/types.h>
#include <sys/param.h>
#include <sys/sysctl.h>
#include <sys/user.h>
#include <sys/vnode.h>

#include <vm/vm_object.h>

#include <kvm.h>
#include <limits.h>
#include <fcntl.h>
#include <stdio.h>
#include <strings.h>

#include "pmap.h"

char *
make_vmo_type(t)
    objtype_t t;
{
    static char *types[]= {	"OBJT_DEFAULT", "OBJT_SWAP", "OBJT_VNODE", 
				"OBJT_DEVICE", "OBJT_DEAD" };
    return types[(int)t];
}

char *
make_vn_type(t)
    enum vtype t;
{
    static char *types[] = { "VNON", "VREG", "VDIR", "VBLK", "VCHR", 
			     "VLNK", "VSOCK", "VFIFO", "VBAD" };
    return types[(int)t];
}

char *
make_vn_tag(t)
    enum vtagtype t;
{
    static char *types[] = { "VT_NON", "VT_UFS", "VT_NFS", "VT_MFS", 
			     "VT_PC", "VT_LFS", "VT_LOFS", "VT_FDESC", 
			     "VT_PORTAL", "VT_NULL", "VT_UMAP", 
			     "VT_KERNFS", "VT_PROCFS", "VT_AFS", "VT_ISOFS", 
			     "VT_UNION", "VT_MSDOSFS", "VT_DEVFS", "VT_TFS", 
			     "VT_VFS", "VT_CODA", "VT_NTFS" };
    return types[(int)t];	
}

char *
print_bits(reg, bits)
    u_long reg;
    bit_t *bits;
{
    register int i, first=1;
    static char buff[1024];
	
    sprintf(buff,"0x%lx<", reg);
    for(i=0;;i++) {
	if(!bits[i].name[0]) break;
	if(reg & bits[i].mask) {
	    if(!first)
		strcat(buff,",");
	    else first = 0;
	    strcat(buff,bits[i].name);
	}
    }
    strcat(buff,">");

    return buff;
}
